.\" gd_rename.3.  The gd_rename man page.
.\"
.\" Copyright (C) 2008, 2009, 2010, 2011, 2012, 2013, 2014 D. V. Wiebe
.\"
.\""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""
.\"
.\" This file is part of the GetData project.
.\"
.\" Permission is granted to copy, distribute and/or modify this document
.\" under the terms of the GNU Free Documentation License, Version 1.2 or
.\" any later version published by the Free Software Foundation; with no
.\" Invariant Sections, with no Front-Cover Texts, and with no Back-Cover
.\" Texts.  A copy of the license is included in the `COPYING.DOC' file
.\" as part of this distribution.
.\"
.TH gd_rename 3 "16 October 2014" "Version 0.9.0" "GETDATA"
.SH NAME
gd_rename \(em change the name of a dirfile field or alias
.SH SYNOPSIS
.B #include <getdata.h>
.HP
.nh
.ad l
.BI "int gd_rename(DIRFILE *" dirfile ", const char"
.BI * old_code ", const char *" new_name ", unsigned int " flags );
.hy
.ad n
.SH DESCRIPTION
The
.BR gd_rename ()
function changes the name of the field or alias specified by
.IR old_code ,
which should not contain a representation suffix, defined in the dirfile
specified by
.IR dirfile
to
.IR new_name .
If the new name is the same as the old name, this function does nothing and
returns no error.

When renaming a metafield, the metafield should be specified in
.I old_code
by its full (slashed) field code, while
.I new_name
should only contain the new name (without slash).

If 
.I old_code
specifies a top-level field with meta subfields, the subfields will be renamed,
too.  By default, this function also updates
.B ALIAS
entries whose target contains
.I old_code
to point to the new field.  Similarly, specifying the
.B GD_REN_UPDB
flag will cause this function to modify any field entry containing
.IR old_code .
As a result, this function may cause more than one metadata fragment to be
modified.

The
.I flags
parameter should be zero or more of the following flags, bitwise or'd together:
.TP
.B GD_REN_DANGLE
Don't update
.B ALIAS
entries, instead turning them into dangling aliases.
.TP
.B GD_REN_DATA
if
.I old_code
specifies a
.B RAW
field, the binary file associated with the field will be renamed as well.
Without this flag, no changes are made to the binary file.  In this case, the
field's I/O pointer will be reset to the beginning-of-frame.  If
.I field_code
specifies a field of type other than
.BR RAW ,
this flag is ignored.
.TP
.B GD_REN_FORCE
When updating field metadata (either the target of an alias, or else when
specified along with
.BR GD_REN_UPDB ), 
skip updating field codes which would be invalid (due to
.B /INCLUDE
affixes).  Without this flag, such invalid field codes causes this function to
fail with the error
.BR GD_E_BAD_CODE .
.TP
.B GD_REN_UPDB
Rename the field in any other field specifications which use this field as an
input (either as a vector input field to a derived field, or else as a scalar
field parameter).  Without this flag, fields which depend on the old name of
this field are left unmodified.

.SH RETURN VALUE
On success,
.BR gd_rename ()
returns zero.  On error, -1 is returned and the dirfile error is set to a
non-zero error value.  Possible error values are:
.TP 8
.B GD_E_ACCMODE
The specified dirfile was opened read-only.
.TP
.B GD_E_ALLOC
The library was unable to allocate memory.
.TP
.B GD_E_BAD_CODE
The field specified by
.I old_code
was not found.  Or else the resultant metadata update tried to change a
field code into something prohibited by a fragment's affixes.
.TP
.B GD_E_BAD_DIRFILE
The supplied dirfile was invalid.
.TP
.B GD_E_BAD_FIELD_TYPE
An attempt was made to rename the immutable
.I INDEX
field.
.TP
.B GD_E_DUPLICATE
The new name specified is already in use by another entry.
.TP
.B GD_E_IO
An I/O error occurred while attempting to rename the binary file.
.TP
.B GD_E_PROTECTED
The metadata of the format specification fragment containing the renamed entry,
or another entry affected by this change, was protected from change, or the
binary data of the fragment was protected from change and a binary file move
was requested.
.TP
.B GD_E_UNKNOWN_ENCODING
The encoding scheme of the specified field could not be determined or was not
understood by GetData.
.TP
.B GD_E_UNSUPPORTED
The encoding scheme of the field does not support binary file renaming.
.PP
The dirfile error may be retrieved by calling
.BR gd_error (3).
A descriptive error string for the last error encountered can be obtained from
a call to
.BR gd_error_string (3).
.SH SEE ALSO
.BR gd_metaflush (3),
.BR gd_open (3),
.BR gd_error (3),
.BR gd_error_string (3),
.BR dirfile (5),
.BR dirfile-format (5)
